diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 88944d9a3a..dedd7a0429 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -1062,6 +1062,7 @@ OBJS-$(CONFIG_H261_PARSER)             += h261_parser.o
 OBJS-$(CONFIG_H263_PARSER)             += h263_parser.o
 OBJS-$(CONFIG_H264_PARSER)             += h264_parser.o h264_sei.o h264data.o
 OBJS-$(CONFIG_HEVC_PARSER)             += hevc_parser.o hevc_data.o
+OBJS-$(CONFIG_JPEG2000_PARSER)         += jpeg2000_parser.o
 OBJS-$(CONFIG_MJPEG_PARSER)            += mjpeg_parser.o
 OBJS-$(CONFIG_MLP_PARSER)              += mlp_parse.o mlp_parser.o mlp.o
 OBJS-$(CONFIG_MPEG4VIDEO_PARSER)       += mpeg4video_parser.o h263.o \
diff --git a/libavcodec/jpeg2000_parser.c b/libavcodec/jpeg2000_parser.c
new file mode 100644
index 0000000000..3d6bbe8ef7
--- /dev/null
+++ b/libavcodec/jpeg2000_parser.c
@@ -0,0 +1,156 @@
+/*
+ * JPEG2000 parser
+ * Copyright (c) 2000, 2001 Fabrice Bellard
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * JPEG2000 parser.
+ */
+
+#include "parser.h"
+
+typedef struct JPEG2000ParserContext{
+    ParseContext pc;
+    uint64_t bytes_read;
+    uint64_t fheader_state;
+    uint16_t skip_bytes; // ignore any bytes in comments of codestream
+    uint8_t fheader_read;
+    uint8_t frame_type; // 1 if file, 2 if codestream
+    uint8_t reading_file_header;
+    uint8_t skipped_codestream;
+    uint8_t codestream_frame_end;
+}JPEG2000ParserContext;
+
+static inline void reset_context(JPEG2000ParserContext *m)
+{
+    ParseContext *pc = &m->pc;
+
+    pc->frame_start_found= 0;
+    pc->state = 0;
+    m->bytes_read = 0;
+    m->frame_type = 0;
+    m->skipped_codestream = 0;
+    m->fheader_read = 0;
+    m->fheader_state = 0;
+    m->reading_file_header = 0;
+    m->codestream_frame_end = 0;
+    m->skip_bytes = 0;
+}
+/**
+ * Find the end of the current frame in the bitstream.
+ * @return the position of the first byte of the next frame, or -1
+ */
+static int find_frame_end(JPEG2000ParserContext *m, const uint8_t *buf, int buf_size)
+{
+    ParseContext *pc= &m->pc;
+    int i;
+    uint32_t state;
+    state= pc->state;
+
+    if (buf_size == 0) {
+        return 0;
+    }
+
+    for (i = 0; i < buf_size; i++) {
+        state = state << 8 | buf[i];
+        m->bytes_read++;
+        if (m->skip_bytes) {
+            m->skip_bytes--;
+            continue;
+        }
+        if (m->codestream_frame_end) {
+            reset_context(m);
+            return i;
+        }
+        if (m->reading_file_header) {
+            m->fheader_state = m->fheader_state << 8 | buf[i];
+            m->fheader_read++;
+            if (m->fheader_read == 8) {
+                if (m->fheader_state == 0x6A5020200D0A870A) {
+                    if (pc->frame_start_found) {
+                        pc->frame_start_found = 0;
+                        reset_context(m);
+                        return i - 11;
+                    } else {
+                        pc->frame_start_found = 1;
+                        m->frame_type = 1;
+                    }
+                }
+                m->reading_file_header = 0;
+                m->fheader_read = 0;
+            }
+        }
+        if (state == 0x0000000C && m->bytes_read >= 3) {
+            m->reading_file_header = 1;
+        } else if ((state & 0xFFFF) == 0xFF4F) {
+            if (!pc->frame_start_found) {
+                pc->frame_start_found = 1;
+                m->frame_type = 2;
+            } else if (pc->frame_start_found && m->frame_type == 1 && m->skipped_codestream) {
+                reset_context(m);
+                return i - 1;
+            }
+        } else if ((state & 0xFFFF) == 0xFFD9) {
+            if (pc->frame_start_found && m->frame_type == 1) {
+                m->skipped_codestream = 1;
+            } else if (pc->frame_start_found && m->frame_type == 2) {
+                m->codestream_frame_end = 1;
+            }
+        } else if (pc->frame_start_found && (state & 0xFFFF0000) == 0xFF640000) {
+            m->skip_bytes = (state & 0xFFFF);
+        }
+    }
+
+    pc->state= state;
+    return END_NOT_FOUND;
+}
+
+static int jpeg2000_parse(AVCodecParserContext *s,
+                          AVCodecContext *avctx,
+                          const uint8_t **poutbuf, int *poutbuf_size,
+                          const uint8_t *buf, int buf_size)
+{
+    JPEG2000ParserContext *m = s->priv_data;
+    ParseContext *pc = &m->pc;
+    int next;
+
+    if(s->flags & PARSER_FLAG_COMPLETE_FRAMES){
+        next= buf_size;
+    }else{
+        next= find_frame_end(m, buf, buf_size);
+
+        if (ff_combine_frame(pc, next, &buf, &buf_size) < 0) {
+            *poutbuf = NULL;
+            *poutbuf_size = 0;
+            return buf_size;
+        }
+    }
+
+    *poutbuf = buf;
+    *poutbuf_size = buf_size;
+    return next;
+}
+
+AVCodecParser ff_jpeg2000_parser = {
+    .codec_ids      = { AV_CODEC_ID_JPEG2000 },
+    .priv_data_size = sizeof(JPEG2000ParserContext),
+    .parser_parse   = jpeg2000_parse,
+    .parser_close   = ff_parse_close,
+};
\ No newline at end of file
diff --git a/libavcodec/parsers.c b/libavcodec/parsers.c
index 9fbf182594..7d75cea830 100644
--- a/libavcodec/parsers.c
+++ b/libavcodec/parsers.c
@@ -48,6 +48,7 @@ extern AVCodecParser ff_h261_parser;
 extern AVCodecParser ff_h263_parser;
 extern AVCodecParser ff_h264_parser;
 extern AVCodecParser ff_hevc_parser;
+extern AVCodecParser ff_jpeg2000_parser;
 extern AVCodecParser ff_mjpeg_parser;
 extern AVCodecParser ff_mlp_parser;
 extern AVCodecParser ff_mpeg4video_parser;